<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates&#x2F;framework&#x2F;drivers&#x2F;devices&#x2F;pl011&#x2F;src&#x2F;lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../icecap_pl011_driver/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
</pre><pre class="rust"><code><span class="attribute">#![<span class="ident">no_std</span>]</span>

<span class="kw">use</span> <span class="ident">core::ops::Deref</span>;

<span class="kw">use</span> <span class="ident">tock_registers</span>::{
    <span class="ident">interfaces</span>::{<span class="ident">Readable</span>, <span class="ident">Writeable</span>},
    <span class="ident">register_structs</span>,
    <span class="ident">registers::ReadWrite</span>,
};

<span class="kw">use</span> <span class="ident">icecap_driver_interfaces::SerialDevice</span>;

<span class="comment">// TODO use structured bitfields</span>

<span class="kw">const</span> <span class="ident">PL011_UARTFR_TXFF</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">5</span>;
<span class="kw">const</span> <span class="ident">PL011_UARTFR_RXFE</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">4</span>;

<span class="macro">register_structs!</span> {
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">non_snake_case</span>)]</span>
    <span class="kw">pub</span> <span class="ident">Pl011RegisterBlock</span> {
        (<span class="number">0x000</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">DR</span>: <span class="ident">ReadWrite</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>),
        (<span class="number">0x001</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">_reserved0</span>),
        (<span class="number">0x018</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">FR</span>: <span class="ident">ReadWrite</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>),
        (<span class="number">0x01c</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">_reserved1</span>),
        (<span class="number">0x038</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">IMSC</span>: <span class="ident">ReadWrite</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>),
        (<span class="number">0x03c</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">_reserved2</span>),
        (<span class="number">0x044</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">ICR</span>: <span class="ident">ReadWrite</span><span class="op">&lt;</span><span class="ident">u32</span><span class="op">&gt;</span>),
        (<span class="number">0x048</span> <span class="op">=</span><span class="op">&gt;</span> @<span class="ident">END</span>),
    }
}

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Pl011Device</span> {
    <span class="ident">base_addr</span>: <span class="ident">usize</span>,
}

<span class="kw">impl</span> <span class="ident">Pl011Device</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">base_addr</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="self">Self</span> { <span class="ident">base_addr</span> }
    }

    <span class="kw">fn</span> <span class="ident">ptr</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">*</span><span class="kw">const</span> <span class="ident">Pl011RegisterBlock</span> {
        <span class="self">self</span>.<span class="ident">base_addr</span> <span class="kw">as</span> <span class="kw-2">*</span><span class="kw">const</span> <span class="kw">_</span>
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">init</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) {
        <span class="self">self</span>.<span class="ident">IMSC</span>.<span class="ident">set</span>(<span class="number">0x50</span>);
    }
}

<span class="kw">impl</span> <span class="ident">Deref</span> <span class="kw">for</span> <span class="ident">Pl011Device</span> {
    <span class="kw">type</span> <span class="ident">Target</span> <span class="op">=</span> <span class="ident">Pl011RegisterBlock</span>;

    <span class="kw">fn</span> <span class="ident">deref</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="ident"><span class="self">Self</span>::Target</span> {
        <span class="kw">unsafe</span> { <span class="kw-2">&amp;</span><span class="kw-2">*</span><span class="self">self</span>.<span class="ident">ptr</span>() }
    }
}

<span class="kw">impl</span> <span class="ident">SerialDevice</span> <span class="kw">for</span> <span class="ident">Pl011Device</span> {
    <span class="kw">fn</span> <span class="ident">put_char</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">c</span>: <span class="ident">u8</span>) {
        <span class="comment">// TODO queue rather than wait</span>
        <span class="kw">loop</span> {
            <span class="kw">if</span> <span class="self">self</span>.<span class="ident">FR</span>.<span class="ident">get</span>() <span class="op">&amp;</span> <span class="ident">PL011_UARTFR_TXFF</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span> {
                <span class="kw">break</span>;
            }
        }
        <span class="self">self</span>.<span class="ident">DR</span>.<span class="ident">set</span>(<span class="ident">c</span>)
    }

    <span class="kw">fn</span> <span class="ident">get_char</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">FR</span>.<span class="ident">get</span>() <span class="op">&amp;</span> <span class="ident">PL011_UARTFR_RXFE</span> {
            <span class="number">0</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">Some</span>(<span class="self">self</span>.<span class="ident">DR</span>.<span class="ident">get</span>()),
            <span class="kw">_</span> <span class="op">=</span><span class="op">&gt;</span> <span class="prelude-val">None</span>,
        }
    }

    <span class="kw">fn</span> <span class="ident">handle_interrupt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) {
        <span class="self">self</span>.<span class="ident">ICR</span>.<span class="ident">set</span>(<span class="number">0x7f0</span>);
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="icecap_pl011_driver" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>